SystemOrganization addCategory: #FuelPlatform!

Object subclass: #FLExtensionWrapper
	instanceVariableNames: 'targetClass method selector isSource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform'!

!FLExtensionWrapper class methodsFor: 'instance-creation' stamp: 'MaxLeske 2/19/2016 12:42'!
fromPragma: aPragma
	^ self new
		initializeWithPragma: aPragma;
		yourself! !

!FLExtensionWrapper methodsFor: 'private' stamp: 'MaxLeske 2/19/2016 13:32'!
compileInTarget
	| methodSelector source |
	source := self method methodClass theNonMetaClass
		perform: self method selector
		withArguments: (1 to: self method selector numArgs) asArray.
	"actual selector may be different from the one used to store the source"
	methodSelector := self targetClass compile: source.
	self targetClass organization
		classify: self selector
		under: self extensionProtocolName! !

!FLExtensionWrapper methodsFor: 'private' stamp: 'MaxLeske 2/19/2016 13:03'!
copySelector: aSelector ofMethod: aCompiledMethod toClass: aClass
	aClass
		addAndClassifySelector: aSelector
		withMethod: aCompiledMethod copy
		inProtocol: self extensionProtocolName
		notifying: nil! !

!FLExtensionWrapper methodsFor: 'private' stamp: 'MaxLeske 2/19/2016 13:13'!
copyToTarget
	self targetClass
		addAndClassifySelector: self selector
		withMethod: self method copy
		inProtocol: self extensionProtocolName
		notifying: nil! !

!FLExtensionWrapper methodsFor: 'private' stamp: 'TravisCI 2/20/2016 14:12'!
extensionProtocolName
	^ FLPlatform extensionProtocolName! !

!FLExtensionWrapper methodsFor: 'initialize-release' stamp: 'MaxLeske 2/19/2016 13:29'!
initializeWithPragma: aPragma
	| argumentNamesAndValues |
	argumentNamesAndValues := self readArgumentsFrom: aPragma.
	self
		method: aPragma method copy;
		selector: (self
			readSelectorFrom: aPragma
			argumentNames: argumentNamesAndValues first
			argumentValues: argumentNamesAndValues second);
		isSource: (self
			readIsSourceFrom: aPragma
			argumentNames: argumentNamesAndValues first
			argumentValues: argumentNamesAndValues second);
		targetClass: (self
			readTargetClassFrom: aPragma
			argumentNames: argumentNamesAndValues first
			argumentValues: argumentNamesAndValues second)! !

!FLExtensionWrapper methodsFor: 'operations' stamp: 'MaxLeske 2/19/2016 13:31'!
install
	self targetClass ifNil: [ ^ self ].
	
	self isSource ifTrue: [ ^ self compileInTarget ].
	self selector = self method selector ifTrue: [ ^ self renameAndCompileInTarget ].
	
	self copyToTarget! !

!FLExtensionWrapper methodsFor: 'accessing' stamp: 'MaxLeske 2/19/2016 12:41'!
isSource
	^ isSource! !

!FLExtensionWrapper methodsFor: 'accessing' stamp: 'MaxLeske 2/19/2016 12:41'!
isSource: aBoolean
	isSource := aBoolean! !

!FLExtensionWrapper methodsFor: 'accessing' stamp: 'MaxLeske 2/19/2016 12:41'!
method
	^ method! !

!FLExtensionWrapper methodsFor: 'accessing' stamp: 'MaxLeske 2/19/2016 12:41'!
method: aCompiledMethod
	method := aCompiledMethod! !

!FLExtensionWrapper methodsFor: 'initialize-release' stamp: 'MaxLeske 2/19/2016 13:21'!
readArgumentsFrom: aPragma
	^ {
		aPragma key keywords.
		aPragma arguments }! !

!FLExtensionWrapper methodsFor: 'initialize-release' stamp: 'MaxLeske 2/19/2016 13:22'!
readIsSourceFrom: aPragma argumentNames: argumentNames argumentValues: argumentValues
	| index |
	index := argumentNames
		indexOf: 'isSource:'
		ifAbsent: [ ^ false ].
	
	^ argumentValues at: index! !

!FLExtensionWrapper methodsFor: 'initialize-release' stamp: 'MaxLeske 2/19/2016 13:22'!
readSelectorFrom: aPragma argumentNames: argumentNames argumentValues: argumentValues
	| index |
	index := argumentNames
		indexOf: 'selector:'
		ifAbsent: [ ^ aPragma selector ].
	
	^ argumentValues at: index! !

!FLExtensionWrapper methodsFor: 'initialize-release' stamp: 'MaxLeske 2/19/2016 13:30'!
readTargetClassFrom: aPragma argumentNames: argumentNames argumentValues: argumentValues
	^ Smalltalk
		at: (argumentValues at: (argumentNames indexOf: 'flExtensionOf:'))
		ifAbsent: [ ^ nil ]! !

!FLExtensionWrapper methodsFor: 'private' stamp: 'MaxLeske 2/19/2016 13:12'!
renameAndCompileInTarget
	| source methodSelector |
	"We need to change the selector and Squeak has no easy
	way of doing that..."
	source := (self method methodClass decompilerClass new
		decompile: self selector
		in: self method methodClass
		method: self method methodForDecompile)
			decompileString.
	"Fix a compiler glitch that by adding a space between selector and pragma
	end for certain selectors"
	source := source
		copyReplaceAll: 'selector: #=>', String cr
		with: 'selector: #= >', String cr.
	methodSelector := self targetClass compile: source.
	self targetClass organization
		classify: methodSelector
		under: self extensionProtocolName! !

!FLExtensionWrapper methodsFor: 'initialize-release' stamp: 'MaxLeske 2/19/2016 12:41'!
selector
	^ selector! !

!FLExtensionWrapper methodsFor: 'accessing' stamp: 'MaxLeske 2/19/2016 12:41'!
selector: aSymbol
	selector := aSymbol! !

!FLExtensionWrapper methodsFor: 'accessing' stamp: 'MaxLeske 2/19/2016 12:42'!
targetClass
	^ targetClass! !

!FLExtensionWrapper methodsFor: 'accessing' stamp: 'MaxLeske 2/19/2016 12:42'!
targetClass: aClass
	targetClass := aClass! !

Object subclass: #FLPlatform
	instanceVariableNames: ''
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'FuelPlatform'!

FLPlatform subclass: #FLPharoPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform'!

FLPharoPlatform subclass: #FLPharo4Platform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform'!

!FLPharo4Platform class methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 15:57'!
isResponsibleForCurrentPlatform
	^ super isResponsibleForCurrentPlatform and: [
		SystemVersion current version beginsWith: 'Pharo4' ]! !

!FLPharo4Platform methodsFor: 'accessing-files' stamp: 'MaxLeske 2/19/2016 15:28'!
fileNamed: aFileame readStreamDo: aBlock
	aFileame asFileReference writeStreamDo: aBlock! !

!FLPharo4Platform methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 15:09'!
isBigEndian
	^Smalltalk isBigEndian! !

!FLPharo4Platform methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 15:10'!
isSpur
	^ false! !

FLPharoPlatform subclass: #FLPharo5Platform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform'!

!FLPharo5Platform class methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 15:57'!
isResponsibleForCurrentPlatform
	^ super isResponsibleForCurrentPlatform and: [
		SystemVersion current version beginsWith: 'Pharo5' ]! !

!FLPharo5Platform methodsFor: 'accessing-files' stamp: 'MaxLeske 2/19/2016 15:27'!
fileNamed: aFilename readStreamDo: aBlock
	((Smalltalk at: #File) named: aFilename) readStreamDo: aBlock! !

!FLPharo5Platform methodsFor: 'accessing-files' stamp: 'MaxLeske 2/19/2016 15:28'!
fileNamed: aFilename writeStreamDo: aBlock
	((Smalltalk at: #File) named: aFilename) writeStreamDo: aBlock! !

!FLPharo5Platform methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 15:08'!
isBigEndian
	^ (Smalltalk at: #EndianDetector) isBigEndian! !

!FLPharoPlatform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/19/2016 17:30'!
addHacks
	super addHacks.
	
	self
		addNativeBoostComponents;
		addPackageManifest! !

!FLPharoPlatform class methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 13:42'!
addNativeBoostComponents
	Smalltalk
		at: #NBExternalHandle
		ifPresent: [ :handle | ^ self ].
		
	Object variableByteSubclass: #NBExternalHandle
		instanceVariableNames: ''
		classVariableNames: ''
		category: self hacksCategoryName! !

!FLPharoPlatform class methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 13:42'!
addPackageManifest
	Smalltalk
		at: #PackageManifest
		ifPresent: [ ^ self ].
	
	Object subclass: #PackageManifest
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self hacksCategoryName! !

!FLPharoPlatform class methodsFor: 'testing' stamp: 'TravisCI 2/20/2016 14:16'!
isResponsibleForCurrentPlatform
	^ SystemVersion current version beginsWith: 'Pharo'! !

!FLPharoPlatform methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 15:10'!
isSpur
	^ true! !

!FLPlatform class methodsFor: 'private-extensions' stamp: 'MaxLeske 2/19/2016 13:00'!
addExtensions
	self extensionPragmas do: [ :pragma |
		(FLExtensionWrapper fromPragma: pragma) install ]! !

!FLPlatform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/19/2016 13:39'!
addHacks
	self addExtensions! !

!FLPlatform class methodsFor: 'accessing' stamp: 'MaxLeske 2/19/2016 14:52'!
current
	^ Current ifNil: [ Current := self detectPlatform ]! !

!FLPlatform class methodsFor: 'private' stamp: 'MaxLeske 2/19/2016 11:14'!
detectPlatform
	| matches mostSpecific |
	matches := self allSubclasses 
		select: [ :class | class isResponsibleForCurrentPlatform ].
	mostSpecific := matches first.
	matches do: [ :class |
		class allSubclasses size < mostSpecific allSubclasses size ifTrue: [
			mostSpecific := class ] ].
	
	^ mostSpecific new! !

!FLPlatform class methodsFor: 'private-extensions' stamp: 'MaxLeske 2/19/2016 13:16'!
extensionPragmas
	^ #(
		flExtensionOf:
		flExtensionOf:selector:
		flExtensionOf:isSource:) gather: [ :selector |
			Pragma
				allNamed: selector
				from: self class
				to: FLPlatform ]! !

!FLPlatform class methodsFor: 'accessing' stamp: 'TravisCI 2/20/2016 14:12'!
extensionProtocolName
	^ '*FuelPlatformExtensions'! !

!FLPlatform class methodsFor: 'private-hacks-metacello' stamp: 'MaxLeske 2/19/2016 17:23'!
fixMetacello! !

!FLPlatform class methodsFor: 'accessing' stamp: 'TravisCI 2/20/2016 14:11'!
hacksCategoryName
	^ 'FuelPlatformHacks'! !

!FLPlatform class methodsFor: 'class initialization' stamp: 'TravisCI 2/20/2016 13:54'!
initialize
	"initialize will only be sent to the defining class, not its subclasses"
	self current class
		addHacks;
		addExtensions! !

!FLPlatform class methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 14:54'!
isResponsibleForCurrentPlatform
	^ self subclassResponsibility! !

!FLPlatform class methodsFor: 'private-convenience' stamp: 'TravisCI 2/20/2016 14:11'!
removeModifications
	(PackageInfo named: self extensionProtocolName) extensionMethods do: [ :methodReference |
		methodReference actualClass removeSelector: methodReference selector ].
	(PackageInfo named: self hacksCategoryName) in: [ :hacks |
		hacks classes do: [ :classOrTrait |
			classOrTrait removeFromSystem ].
		PackageOrganizer default  unregisterPackage: hacks ].
	SystemOrganizer default removeCategory: self hacksCategoryName! !

!FLPlatform methodsFor: 'accessing-files' stamp: 'MaxLeske 2/19/2016 15:29'!
fileNamed: aFilename readStreamDo: aBlock
	self subclassResponsibility! !

!FLPlatform methodsFor: 'accessing-files' stamp: 'MaxLeske 2/19/2016 15:29'!
fileNamed: aFilename writeStreamDo: aBlock
	self subclassResponsibility! !

!FLPlatform methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 14:59'!
isBigEndian
	^ self subclassResponsibility! !

!FLPlatform methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 15:11'!
isSpur
	^ true! !

FLPlatform subclass: #FLSqueakPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform'!

FLSqueakPlatform subclass: #FLSqueak4Platform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform'!

FLSqueak4Platform subclass: #FLSqueak46Platform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform'!

!FLSqueak46Platform class methodsFor: 'private-hacks-metacello' stamp: 'MaxLeske 2/19/2016 17:25'!
fixMetacello
	super fixMetacello.
	
	self fixSystemVersion! !

!FLSqueak46Platform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/19/2016 11:19'!
fixSystemVersion
	"This is ridiculous but until release the 4.6 image seems to identify itself as 4.5 (WTF!!)"
	(Smalltalk imageName includesSubString: '4.6') ifFalse: [ ^ self ].

	SystemVersion current version: 'Squeak4.6'! !

!FLSqueak46Platform class methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 11:20'!
isResponsibleForCurrentPlatform
	^ super isResponsibleForCurrentPlatform and: [
		(SystemVersion current version beginsWith: 'Squeak4.6') or: [
			"See #fixSystemVersion"
			(Smalltalk imageName includesSubString: '4.6') ] ]! !

!FLSqueak4Platform class methodsFor: 'private-hacks-metacello' stamp: 'MaxLeske 2/19/2016 17:28'!
fixMetacello
	super fixMetacello.
	
	self fixPlatformAttributes! !

!FLSqueak4Platform class methodsFor: 'private-hacks-metacello' stamp: 'MaxLeske 2/19/2016 17:28'!
fixPlatformAttributes
	| versions |
	versions := { 'Squeak4.1'. 'Squeak4.2'. 'Squeak4.3'. 'Squeak4.4'. 'Squeak4.5'. 'Squeak4.6' }.
		
	Smalltalk 
		at: #MetacelloSqueakPlatform
		ifPresent: [ :platform |
			(Smalltalk at: #Utilities) setAuthorInitials: 'MaxLeske'.
			(Smalltalk at: #MetacelloSqueakPlatform) compile: (self newSqueakPlatformAttributesSourceFrom: versions).
			(Smalltalk at: #Utilities) setAuthorInitials: '' ]! !

!FLSqueak4Platform class methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 15:57'!
isResponsibleForCurrentPlatform
	^ super isResponsibleForCurrentPlatform and: [
		SystemVersion current version beginsWith: 'Squeak4' ]! !

!FLSqueak4Platform methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 15:12'!
isSpur	
	^ false! !

FLSqueakPlatform subclass: #FLSqueak5Platform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPlatform'!

!FLSqueak5Platform class methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 15:58'!
isResponsibleForCurrentPlatform
	^ super isResponsibleForCurrentPlatform and: [
		SystemVersion current version beginsWith: 'Squeak5' ]! !

!FLSqueakPlatform class methodsFor: 'private-extensions-string' stamp: 'MaxLeske 2/19/2016 09:26'!
=> anObject
	<flExtensionOf: #String>	
	^ anObject isBehavior
		ifTrue: [ClassBinding key: self value: anObject]
		ifFalse: [Global key: self value: anObject]! !

!FLSqueakPlatform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/19/2016 13:40'!
addClusters
	Smalltalk
		at: #FLMethodContextCluster
		ifPresent: [ :x | ^ self ].
		
	FLVariableObjectCluster subclass: #FLMethodContextCluster
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self hacksCategoryName! !

!FLSqueakPlatform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/19/2016 13:41'!
addContext
	Smalltalk
		at: #Context
		ifPresent: [ :x | ^ self ].
		
	Object 
		subclass: #Context
		instanceVariableNames: '' 
		classVariableNames: '' 
		poolDictionaries: '' 
		category: self hacksCategoryName! !

!FLSqueakPlatform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/19/2016 13:41'!
addEnvironment
	"Don't name the category 'Fuel-Hacks'. That category will be nuked on load"	
	Smalltalk
		at: #Environment
		ifPresent: [ :x | ^ self ].
		
	Object 
		subclass: #Environment
		instanceVariableNames: '' 
		classVariableNames: '' 
		poolDictionaries: '' 
		category: self hacksCategoryName! !

!FLSqueakPlatform class methodsFor: 'private-hacks' stamp: 'TravisCI 2/20/2016 13:55'!
addHacks
	super addHacks.
	
	self
		addTraits;
		addEnvironment;
		addNativeBoostComponents;
		addContext;
		addClusters;
		addPackageManifest! !

!FLSqueakPlatform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/19/2016 13:41'!
addNativeBoostComponents
	Smalltalk
		at: #NBExternalHandle
		ifPresent: [ :handle | ^ self ].
		
	Object variableByteSubclass: #NBExternalHandle
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self hacksCategoryName! !

!FLSqueakPlatform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/19/2016 13:41'!
addPackageManifest
	Smalltalk
		at: #PackageManifest
		ifPresent: [ :manifest | ^ self ].
	
	Object subclass: #PackageManifest
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self hacksCategoryName! !

!FLSqueakPlatform class methodsFor: 'private-hacks' stamp: 'MaxLeske 2/19/2016 13:41'!
addTraits
	(Smalltalk classOrTraitNamed: #TClass) ifNil: [
		Trait 
			named: #TClass
			uses: {}
			category: self hacksCategoryName ].
	(Smalltalk classOrTraitNamed: #TClassDescription) ifNil: [
		Trait 
			named: #TClassDescription
			uses: {}
			category: self hacksCategoryName ].
	(Smalltalk classOrTraitNamed: #TBehavior) ifNil: [
		Trait 
			named: #TBehavior
			uses: {}
			category: self hacksCategoryName ].
	(Smalltalk classOrTraitNamed: #TPureBehavior) ifNil: [
		Trait 
			named: #TPureBehavior
			uses: {}
			category: self hacksCategoryName ].
	(Smalltalk classOrTraitNamed: #TApplyingOnClassSide) ifNil: [
		Trait 
			named: #TApplyingOnClassSide
			uses: {}
			category: self hacksCategoryName ]! !

!FLSqueakPlatform class methodsFor: 'private-extensions-methodcontext' stamp: 'MaxLeske 2/19/2016 09:25'!
assertWellMaterializedInto: aMethodContext in: aTestCase
	<flExtensionOf: #MethodContext isSource: true>
	^ 'assertWellMaterializedInto: aMethodContext in: aTestCase

	aTestCase assert: self ~~ aMethodContext. 
	aTestCase assert: (self class == aMethodContext class).
	aTestCase assert: self tempNames = aMethodContext  tempNames.
	aTestCase assert: pc = aMethodContext pc.
	aTestCase assert: stackp = aMethodContext stackPtr.
	closureOrNil isNil 
		ifTrue: [ aTestCase assert: aMethodContext closure isNil ]
		ifFalse: [ closureOrNil assertWellMaterializedInto: aMethodContext closure in: aTestCase ].
	aTestCase assert: receiver = aMethodContext receiver.
	aTestCase assert: (method isEqualRegardlessTrailerTo: aMethodContext method).
	sender isNil 
		ifTrue: [ aTestCase assert: aMethodContext sender isNil ]
		ifFalse: [ sender assertWellMaterializedInto: aMethodContext sender in: aTestCase ]'! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flserializationtest' stamp: 'MaxLeske 2/19/2016 09:15'!
defaultTimeout
	<flExtensionOf: #FLSerializationTest>
	"We have some long running tests which will be terminated by Squeaks
	implementation of TestCase>>runCase. Increase the default fro 5 to 60 seconds"
	
	^ 60 "seconds"! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flserializationtest' stamp: 'MaxLeske 2/19/2016 09:15'!
deleteFileNamed: aFilename
	<flExtensionOf: #FLSerializationTest>
	 FileDirectory default deleteFileNamed: aFilename! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/19/2016 09:05'!
duringTestCompileSilently: code
	<flExtensionOf: #ClassDescription>
	^ self 
		duringTestCompileSilently: code 
		storeSource: true! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/19/2016 09:06'!
duringTestCompileSilently: code classified: aCategory
	<flExtensionOf: #ClassDescription>
	^ self 
		duringTestCompileSilently: code
		storeSource: true
		classified: aCategory! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/19/2016 09:06'!
duringTestCompileSilently: code storeSource: storeSource
	<flExtensionOf: #ClassDescription>
	^ self
		duringTestCompileSilently: code
		storeSource: storeSource
		classified: ''! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/19/2016 09:06'!
duringTestCompileSilently: code storeSource: storeSource classified: aCategory
	<flExtensionOf: #ClassDescription>
	^ Utilities 
		useAuthor: 'TestsAuthor'
		during: [ [
			self 
				compile: code
				classified: (aCategory ifNil: [ '''' ])
				withStamp: nil 
				notifying: nil 
				logSource: storeSource ] fuelValueWithoutNotifications ]! !

!FLSqueakPlatform class methodsFor: 'private-extensions-gradientfillstyle' stamp: 'MaxLeske 2/19/2016 10:28'!
equals: anGradientFillStyle
	<flExtensionOf: #GradientFillStyle selector: #= >
	"Answer whether equal."

	^ self pixelRamp == anGradientFillStyle pixelRamp "LRU should make identity equal"! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flbasicserializationtest' stamp: 'MaxLeske 2/19/2016 09:11'!
expectedFailures
	<flExtensionOf: #FLBasicSerializationTest>
	| failures minorVersion |
	failures := #(testConsiderCustomWideSymbolGlobal).
	minorVersion := (SystemVersion current version findTokens: 'Squeak') first last. 
	minorVersion asInteger < 3 ifTrue: [ 
		failures := failures, #(testSetElement testSetWithNil testSetWithSetElement) ].
	
	^ failures! !

!FLSqueakPlatform class methodsFor: 'private-extensions-methodcontext' stamp: 'MaxLeske 2/19/2016 09:25'!
initializeWith: aPc stackPtr: aStackPtr method: aMethod receiver: aReceiver sender: aSender
	<flExtensionOf: #MethodContext isSource: true>
	^ 'initializeWith: aPc stackPtr: aStackPtr method: aMethod receiver: aReceiver sender: aSender
	pc := aPc.
	stackp := aStackPtr.
	method := aMethod.
	receiver := aReceiver.
	sender := aSender.
	'! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/19/2016 09:06'!
instanceVariableNamesDo: anUnaryBlock
	<flExtensionOf: #ClassDescription>
	"This is part of the interface between the compiler and a class''s instance or field names.
	 The class should enumerate anUnaryBlock with the instance variable name strings.  The order is important. Names evaluated later will override the
	 same names occurring earlier."

	| superInstSize |
	(superInstSize := self superclass notNil ifTrue: [self superclass instSize] ifFalse: [0]) > 0 ifTrue:
		[self superclass instanceVariableNamesDo: anUnaryBlock].
	1 to: self instSize - superInstSize do:
		[:i| anUnaryBlock value: (instanceVariables at: i)]! !

!FLSqueakPlatform class methodsFor: 'testing' stamp: 'TravisCI 2/20/2016 14:17'!
isResponsibleForCurrentPlatform
	^ SystemVersion current version beginsWith: 'Squeak'! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classfactoryfortestcase' stamp: 'MaxLeske 2/19/2016 09:08'!
newName
	<flExtensionOf: #ClassFactoryForTestCase>
	| postFix |
	postFix := (self createdClasses size + 1) printString.
	^(#ClassForTestToBeDeleted, postFix) asSymbol! !

!FLSqueakPlatform class methodsFor: 'private-hacks-metacello' stamp: 'MaxLeske 2/19/2016 13:43'!
newSqueakPlatformAttributesSourceFrom: aCollection
	^ String streamContents: [ :stream | 
		stream nextPutAll: 'defaultPlatformAttributes
	| attributes versionString |
	attributes := OrderedCollection with: #squeakCommon with: #squeak.
	Smalltalk
		at: #SystemVersion
		ifPresent: [:cl | 
			versionString := cl current version.
			(versionString beginsWith: ''Squeak3.10'')
				ifTrue: [attributes add: #''squeak3.10.x''].
			(versionString beginsWith: ''Squeak4'')
				ifTrue: [attributes add: #''squeak4.x''.'.
		aCollection do: [ :version |
			stream
				nextPutAll: '(versionString beginsWith: ''';
				nextPutAll:  version;
				nextPutAll: ''') ifTrue: [ attributes add: #''';
				nextPutAll: version asLowercase;
				nextPutAll: '.x''] ifFalse: [ ' ].
		stream 
			nextPutAll: (String newFrom: ((1 to: aCollection size + 2) collect: [ :i | $] ]));
			nextPutAll: '. ^ attributes' ]! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flserializationtest' stamp: 'MaxLeske 2/19/2016 09:15'!
newSubclassNamed: nameString of: aClass  instanceVariableNames: ivNamesString classVariableNames: classVarsString
	<flExtensionOf: #FLSerializationTest>
	| class |
	SystemChangeNotifier uniqueInstance doSilently: [
		class := aClass
			subclass: nameString asSymbol
			instanceVariableNames: ivNamesString
			classVariableNames:  classVarsString
			poolDictionaries: ''
			category: self classFactory defaultCategory
	].
	self classFactory createdClasses add: class.
	^ class! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classdescription' stamp: 'MaxLeske 2/19/2016 09:06'!
renameSilently: aName
	<flExtensionOf: #ClassDescription>
	 [ self rename: aName] fuelValueWithoutNotifications! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classfactoryfortestcase' stamp: 'MaxLeske 2/19/2016 09:08'!
silentlyNewSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString
	<flExtensionOf: #ClassFactoryForTestCase>
	^ self silentlyNewSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString category: self defaultCategoryPostfix
! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classfactoryfortestcase' stamp: 'MaxLeske 2/19/2016 09:08'!
silentlyNewSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString category: category
	<flExtensionOf: #ClassFactoryForTestCase>
	| newClass |
	[ newClass := aClass 
			subclass: self newName 
			instanceVariableNames: ivNamesString 
			classVariableNames: classVarsString 
			poolDictionaries: '' 
			category: (self packageName, '-', category) asSymbol.
	] fuelValueWithoutNotifications.

	self createdClasses add: newClass.
	^newClass
	! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classfactoryfortestcase' stamp: 'MaxLeske 2/19/2016 09:09'!
silentlyNewSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString package: packageName
	<flExtensionOf: #ClassFactoryForTestCase>
	| newClass |
	[ newClass := aClass 
			subclass: self newName 
			instanceVariableNames: ivNamesString 
			classVariableNames: classVarsString 
			poolDictionaries: '' 
			category: packageName asSymbol.
	] fuelValueWithoutNotifications.

	self createdClasses add: newClass.
	^newClass
	! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flserializationtest' stamp: 'MaxLeske 2/19/2016 09:15'!
tearDown
	<flExtensionOf: #FLSerializationTest>
	super tearDown.
	"Traits should be cleaned before classFactory because it seems class factory only knows how to clean classes, not traits."
	self tearDownTraits.
	self tearDownClassFactory.
	self tearDownGlobalVariables.
	self tearDownInstanceVariables! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flserializationtest' stamp: 'MaxLeske 2/19/2016 09:15'!
tearDownInstanceVariables
	<flExtensionOf: #FLSerializationTest>
	self class withAllSuperclasses do: [ :class |
		class = TestCase ifTrue: [ ^ self ].
		
		class instVarNames do: [ :varName |
			self 
				instVarNamed: varName
				put: nil ] ]! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flcontextserializationtest' stamp: 'MaxLeske 2/19/2016 09:12'!
testContext
	<flExtensionOf: #FLContextSerializationTest>
	"This test should be improved"
	| context1  materializedContext1  |
	context1 := (MethodContext newForMethod: FLPair >> #method1).
	context1 
		initializeWith: 23 
		stackPtr: 1 
		method: FLPair >> #method1 
		receiver:  (FLPair new right: 4; left: 2) 
		sender: nil.
		
	materializedContext1 := self resultOfSerializeAndMaterialize: context1.
	context1 assertWellMaterializedInto: materializedContext1 in: self.! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flcontextserializationtest' stamp: 'MaxLeske 2/19/2016 09:12'!
testContextWithClosureAndSender
	<flExtensionOf: #FLContextSerializationTest>
	"This test should be improved"
	| context1  materializedContext2  context2 |
	
	context1 := (MethodContext newForMethod: FLPair >> #method1).
	context1 
		initializeWith: 23 
		stackPtr: 1 
		method: FLPair >> #method1 
		receiver:  (FLPair new right: 4; left: 2) 
		sender: nil.
	
	context2 := self class blockClosureContextTestingWithSender: context1.
	materializedContext2 := self resultOfSerializeAndMaterialize: context2.
	context2 assertWellMaterializedInto: materializedContext2 in: self.
	
! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flcontextserializationtest' stamp: 'MaxLeske 2/19/2016 09:12'!
testContextWithNilPc
	<flExtensionOf: #FLContextSerializationTest>
	"This test should be improved"
	| context1  materializedContext1  |
	context1 := (MethodContext newForMethod: FLPair >> #method1).
	context1 
		initializeWith: nil 
		stackPtr: 1 
		method: FLPair >> #method1 
		receiver:  (FLPair new right: 4; left: 2) 
		sender: nil.
		
	materializedContext1 := self resultOfSerializeAndMaterialize: context1.
	context1 assertWellMaterializedInto: materializedContext1 in: self.! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flcontextserializationtest' stamp: 'MaxLeske 2/19/2016 09:13'!
testContextWithSender
	<flExtensionOf: #FLContextSerializationTest>
	"This test should be improved"
	| context1 context2 materializedContext1 |
	context1 := (MethodContext newForMethod: FLPair >> #method1).
	context1 
		initializeWith: 23 
		stackPtr: 1 
		method: FLPair >> #method1 
		receiver:  (FLPair new right: 4; left: 2) 
		sender: nil.
		
	context2 := (MethodContext newForMethod: FLPair >> #method2).
	context2 
		initializeWith: 18 
		stackPtr: 1 
		method: FLPair >> #method2 
		receiver:  (FLPair new right: 5; left: 6) 
		sender: nil.

	context1 privSender:  context2.
		
	materializedContext1 := self resultOfSerializeAndMaterialize: context1.
	context1 assertWellMaterializedInto: materializedContext1 in: self.! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flcontextserializationtest' stamp: 'MaxLeske 2/19/2016 09:13'!
testContextWithTemp
	<flExtensionOf: #FLContextSerializationTest>
	"This test should be improved"
	| context1  materializedContext1  |
	context1 := (MethodContext newForMethod: FLPair >> #methodWithTemp).
	context1 
		initializeWith: nil 
		stackPtr: 1 
		method: FLPair >> #methodWithTemp 
		receiver:  (FLPair new right: 4; left: 2) 
		sender: nil.
	context1 tempNamed: 'string' put: 'capo'.
	
	materializedContext1 := self resultOfSerializeAndMaterialize: context1.
	self assert: (materializedContext1 tempNamed: 'string') = 'capo'.
	context1 assertWellMaterializedInto: materializedContext1 in: self.! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flbasicserializationtest' stamp: 'MaxLeske 2/19/2016 09:11'!
testDateOffsets
	<flExtensionOf: #FLBasicSerializationTest>
	| bst sast materialized object |
	bst := TimeZone timeZones third.
	sast := TimeZone timeZones fourth.
	
	DateAndTime localTimeZone: bst.
	self assert: DateAndTime now offset equals: 1 hour.
	object := Date fromDays: 37023.
	self assert: object start offset equals: 0 hours.
	materialized := self resultOfSerializeAndMaterialize: object.
	self assert: materialized start offset equals: 0 hours.
	
	DateAndTime localTimeZone: sast.
	self assert: DateAndTime now offset equals: 2 hours.
	object := Date fromDays: 37023.
	self assert: object start offset equals: 0 hours.
	materialized := self resultOfSerializeAndMaterialize: object.
	self assert: materialized start offset equals: 0 hours.

	object := Date fromDays: 37023.
	object start: DateAndTime now.
	self assert: object start offset equals: 2 hours.
	materialized := self resultOfSerializeAndMaterialize: object.
	self assert: materialized start offset equals: 2 hours! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flbasicserializationtest' stamp: 'MaxLeske 2/19/2016 09:11'!
testDateOffsetsChanging
	<flExtensionOf: #FLBasicSerializationTest>
	| bst sast object |
	bst := TimeZone timeZones third.
	sast := TimeZone timeZones fourth.
	
	DateAndTime localTimeZone: bst.
	self assert: DateAndTime now offset equals: 1 hour.
	object := Date fromDays: 37023.
	object start: DateAndTime now.
	self assert: object start offset equals: 1 hours.
	self serialize: object.
	
	DateAndTime localTimeZone: sast.
	self assert: DateAndTime now offset equals: 2 hours.
	object := Date fromDays: 37023.
	self assert: object start offset equals: 0 hours.
	"serialization sould be independent of timezone change"
	self assert: self materialized start offset equals: 1 hour
	! !

!FLSqueakPlatform class methodsFor: 'private-extensions-flmigrationtest' stamp: 'MaxLeske 2/19/2016 09:14'!
testFormatFixedToVariable
	<flExtensionOf: #FLMigrationTest>
	"Tests that serializer can tolerate a format change from a *fixed* class to *weak/variable*.
	Notice, however, that the other way around (variable to fixed) doesn't work so far"
	
	| materialized |
	self serialize: FLPair new.
	materialized := [ self during: [ self materialized ] rename: FLPair as: FLWeakClassMock ]
		on: AttemptToWriteReadOnlyGlobal
		do: [ :ex | ex resume: true ].
	self assert: materialized size = 0! !

!FLSqueakPlatform class methodsFor: 'private-extensions-utilities' stamp: 'MaxLeske 2/19/2016 11:38'!
useAuthor: aString during: aBlock
	<flExtensionOf: #Utilities isSource: true>
	<flExtensionClassSide>
	^ 'useAuthor: aString during: aBlock
	| previous |
	previous := AuthorInitials.
	AuthorInitials := aString.
	^ aBlock ensure: [ AuthorInitials := previous ]'! !

!FLSqueakPlatform class methodsFor: 'private-extensions-classfactoryfortestcase' stamp: 'MaxLeske 2/19/2016 09:09'!
withNotificationsNewClassWithInstanceVariableNames: instanceVariableNames
	<flExtensionOf: #ClassFactoryForTestCase>
	^ self newSubclassOf: Object instanceVariableNames: instanceVariableNames classVariableNames:  '' category: self defaultCategoryPostfix
	! !

!FLSqueakPlatform methodsFor: 'accessing-files' stamp: 'MaxLeske 2/19/2016 15:26'!
fileNamed: aFilename readStreamDo: aBlock
	FileStream
		readOnlyFileNamed: aFilename
		do: aBlock! !

!FLSqueakPlatform methodsFor: 'accessing-files' stamp: 'MaxLeske 2/19/2016 15:27'!
fileNamed: aFilename writeStreamDo: aBlock
	FileStream
		forceNewFileNamed: aFilename
		do: aBlock! !

!FLSqueakPlatform methodsFor: 'testing' stamp: 'MaxLeske 2/19/2016 14:57'!
isBigEndian
	^ Smalltalk isBigEndian! !
FLPlatform initialize!
